package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;
    public static boolean dontPause;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
        mostCurrent = this;
		if (processBA == null) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.setActivityPaused(true);
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(this, processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null)
            return;
        if (this != mostCurrent)
			return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        if (!dontPause)
            BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        else
            BA.LogInfo("** Activity (main) Pause event (activity is not paused). **");
        if (mostCurrent != null)
            processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        if (!dontPause) {
            processBA.setActivityPaused(true);
            mostCurrent = null;
        }

        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
            main mc = mostCurrent;
			if (mc == null || mc != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
            if (mc != mostCurrent)
                return;
		    processBA.raiseEvent(mc._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

private static BA killProgramHelper(BA ba) {
    if (ba == null)
        return null;
    anywheresoftware.b4a.BA.SharedProcessBA sharedProcessBA = ba.sharedProcessBA;
    if (sharedProcessBA == null || sharedProcessBA.activityBA == null)
        return null;
    return sharedProcessBA.activityBA.get();
}
public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = killProgramHelper(main.mostCurrent == null ? null : main.mostCurrent.processBA);
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

BA.applicationContext.stopService(new android.content.Intent(BA.applicationContext, starter.class));
}
public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.B4XViewWrapper.XUI _xui = null;
public b4a.example.flexgrid _flexgrid1 = null;
public b4a.example.eval _ev = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button2 = null;
public b4a.example.starter _starter = null;
public static void  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_create", false))
	 {Debug.delegate(mostCurrent.activityBA, "activity_create", new Object[] {_firsttime}); return;}
ResumableSub_Activity_Create rsub = new ResumableSub_Activity_Create(null,_firsttime);
rsub.resume(processBA, null);
}
public static class ResumableSub_Activity_Create extends BA.ResumableSub {
public ResumableSub_Activity_Create(b4a.example.main parent,boolean _firsttime) {
this.parent = parent;
this._firsttime = _firsttime;
}
b4a.example.main parent;
boolean _firsttime;
boolean _b = false;
int _i = 0;
anywheresoftware.b4a.objects.CSBuilder _cs = null;
int step9;
int limit9;
int step21;
int limit21;

@Override
public void resume(BA ba, Object[] result) throws Exception{
RDebugUtils.currentModule="main";

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
RDebugUtils.currentLine=131074;
 //BA.debugLineNum = 131074;BA.debugLine="Activity.LoadLayout(\"Layout1\")";
parent.mostCurrent._activity.LoadLayout("Layout1",mostCurrent.activityBA);
RDebugUtils.currentLine=131075;
 //BA.debugLineNum = 131075;BA.debugLine="Ev.Initialize(FlexGrid1)";
parent.mostCurrent._ev._initialize(mostCurrent.activityBA,parent.mostCurrent._flexgrid1);
RDebugUtils.currentLine=131076;
 //BA.debugLineNum = 131076;BA.debugLine="FlexGrid1.ColsName=Array As String(\"\",\"N\",\"On\",\"N";
parent.mostCurrent._flexgrid1._setcolsname(new String[]{"","N","On","Name","Img","Digit"});
RDebugUtils.currentLine=131077;
 //BA.debugLineNum = 131077;BA.debugLine="FlexGrid1.ColsWidth=Array As Int(75dip,50dip,50di";
parent.mostCurrent._flexgrid1._setcolswidth(new int[]{anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (75)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (50)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (50)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (60)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (100))});
RDebugUtils.currentLine=131078;
 //BA.debugLineNum = 131078;BA.debugLine="FlexGrid1.ColsType=Array As Int(FlexGrid1.TypeBut";
parent.mostCurrent._flexgrid1._setcolstype(new int[]{parent.mostCurrent._flexgrid1._typebutton,parent.mostCurrent._flexgrid1._typeint,parent.mostCurrent._flexgrid1._typecheck,parent.mostCurrent._flexgrid1._typestring,parent.mostCurrent._flexgrid1._typeimage,parent.mostCurrent._flexgrid1._typefloat});
RDebugUtils.currentLine=131079;
 //BA.debugLineNum = 131079;BA.debugLine="FlexGrid1.ColsAlignment=Array As String(\"CENTER\",";
parent.mostCurrent._flexgrid1._setcolsalignment(new String[]{"CENTER","CENTER","CENTER","LEFT","LEFT","RIGHT"});
RDebugUtils.currentLine=131081;
 //BA.debugLineNum = 131081;BA.debugLine="FlexGrid1.SetColCustomize(0,0xFF5BC17D,xui.Color_";
parent.mostCurrent._flexgrid1._setcolcustomize((int) (0),(int) (0xff5bc17d),parent.mostCurrent._xui.Color_RGB((int) (240),(int) (240),(int) (240)),parent.mostCurrent._xui.CreateDefaultFont((float) (14)));
RDebugUtils.currentLine=131083;
 //BA.debugLineNum = 131083;BA.debugLine="Dim B As Boolean=False";
_b = anywheresoftware.b4a.keywords.Common.False;
RDebugUtils.currentLine=131084;
 //BA.debugLineNum = 131084;BA.debugLine="For i=1 To 20";
if (true) break;

case 1:
//for
this.state = 4;
step9 = 1;
limit9 = (int) (20);
_i = (int) (1) ;
this.state = 9;
if (true) break;

case 9:
//C
this.state = 4;
if ((step9 > 0 && _i <= limit9) || (step9 < 0 && _i >= limit9)) this.state = 3;
if (true) break;

case 10:
//C
this.state = 9;
_i = ((int)(0 + _i + step9)) ;
if (true) break;

case 3:
//C
this.state = 10;
RDebugUtils.currentLine=131085;
 //BA.debugLineNum = 131085;BA.debugLine="B=Not(B)";
_b = anywheresoftware.b4a.keywords.Common.Not(_b);
RDebugUtils.currentLine=131086;
 //BA.debugLineNum = 131086;BA.debugLine="FlexGrid1.AddRow(Array As Object(\"B\" &i,i,B,\"Use";
parent.mostCurrent._flexgrid1._addrow(new Object[]{(Object)("B"+BA.NumberToString(_i)),(Object)(_i),(Object)(_b),(Object)("User "+BA.NumberToString(_i)),anywheresoftware.b4a.keywords.Common.Null,(Object)(anywheresoftware.b4a.keywords.Common.Rnd((int) (50),(int) (10000))/(double)100)},anywheresoftware.b4a.keywords.Common.True);
 if (true) break;
if (true) break;

case 4:
//C
this.state = 5;
;
RDebugUtils.currentLine=131090;
 //BA.debugLineNum = 131090;BA.debugLine="Dim Cs As CSBuilder";
_cs = new anywheresoftware.b4a.objects.CSBuilder();
RDebugUtils.currentLine=131091;
 //BA.debugLineNum = 131091;BA.debugLine="Cs.Initialize.Color(xui.Color_Red).Append(\"User\")";
_cs.Initialize().Color(parent.mostCurrent._xui.Color_Red).Append(BA.ObjectToCharSequence("User")).Pop().Color(parent.mostCurrent._xui.Color_Blue).Append(BA.ObjectToCharSequence(" 200")).PopAll();
RDebugUtils.currentLine=131093;
 //BA.debugLineNum = 131093;BA.debugLine="FlexGrid1.SetCellvalue(0,0,100)";
parent.mostCurrent._flexgrid1._setcellvalue((int) (0),(int) (0),(Object)(100));
RDebugUtils.currentLine=131094;
 //BA.debugLineNum = 131094;BA.debugLine="FlexGrid1.SetCellvalue(1,3,Cs)";
parent.mostCurrent._flexgrid1._setcellvalue((int) (1),(int) (3),(Object)(_cs.getObject()));
RDebugUtils.currentLine=131095;
 //BA.debugLineNum = 131095;BA.debugLine="FlexGrid1.SetCellvalue(0,4,LoadBitmap(File.DirAss";
parent.mostCurrent._flexgrid1._setcellvalue((int) (0),(int) (4),(Object)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"b4a.png").getObject()));
RDebugUtils.currentLine=131096;
 //BA.debugLineNum = 131096;BA.debugLine="FlexGrid1.SetCellvalue(2,4,LoadBitmap(File.DirAss";
parent.mostCurrent._flexgrid1._setcellvalue((int) (2),(int) (4),(Object)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"b4j.png").getObject()));
RDebugUtils.currentLine=131097;
 //BA.debugLineNum = 131097;BA.debugLine="FlexGrid1.SetCellvalue(4,4,LoadBitmap(File.DirAss";
parent.mostCurrent._flexgrid1._setcellvalue((int) (4),(int) (4),(Object)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"b4i.png").getObject()));
RDebugUtils.currentLine=131099;
 //BA.debugLineNum = 131099;BA.debugLine="FlexGrid1.SetCellCustomize(0,3,xui.Color_Black,xu";
parent.mostCurrent._flexgrid1._setcellcustomize((int) (0),(int) (3),parent.mostCurrent._xui.Color_Black,parent.mostCurrent._xui.Color_Cyan,parent.mostCurrent._xui.CreateDefaultBoldFont((float) (16)));
RDebugUtils.currentLine=131100;
 //BA.debugLineNum = 131100;BA.debugLine="For I=0 To 9";
if (true) break;

case 5:
//for
this.state = 8;
step21 = 1;
limit21 = (int) (9);
_i = (int) (0) ;
this.state = 11;
if (true) break;

case 11:
//C
this.state = 8;
if ((step21 > 0 && _i <= limit21) || (step21 < 0 && _i >= limit21)) this.state = 7;
if (true) break;

case 12:
//C
this.state = 11;
_i = ((int)(0 + _i + step21)) ;
if (true) break;

case 7:
//C
this.state = 12;
RDebugUtils.currentLine=131101;
 //BA.debugLineNum = 131101;BA.debugLine="FlexGrid1.SetCellCustomize(i,1,xui.Color_Blue,xu";
parent.mostCurrent._flexgrid1._setcellcustomize(_i,(int) (1),parent.mostCurrent._xui.Color_Blue,parent.mostCurrent._xui.Color_Yellow,parent.mostCurrent._xui.CreateDefaultBoldFont((float) (16)));
 if (true) break;
if (true) break;

case 8:
//C
this.state = -1;
;
RDebugUtils.currentLine=131104;
 //BA.debugLineNum = 131104;BA.debugLine="Sleep(2000)";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,new anywheresoftware.b4a.shell.DebugResumableSub.DelegatableResumableSub(this, "main", "activity_create"),(int) (2000));
this.state = 13;
return;
case 13:
//C
this.state = -1;
;
RDebugUtils.currentLine=131106;
 //BA.debugLineNum = 131106;BA.debugLine="FlexGrid1.SetCellValue(0,3,\"Totale: \" & Ev.Calcul";
parent.mostCurrent._flexgrid1._setcellvalue((int) (0),(int) (3),(Object)("Totale: "+BA.NumberToString(parent.mostCurrent._ev._calculate("1+sum(0,1,9,1)"))));
RDebugUtils.currentLine=131107;
 //BA.debugLineNum = 131107;BA.debugLine="Log(FlexGrid1.RowCount)";
anywheresoftware.b4a.keywords.Common.LogImpl("2131107",BA.NumberToString(parent.mostCurrent._flexgrid1._getrowcount()),0);
RDebugUtils.currentLine=131108;
 //BA.debugLineNum = 131108;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=262146;
 //BA.debugLineNum = 262146;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_resume", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "activity_resume", null));}
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="End Sub";
return "";
}
public static String  _button1_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "button1_click", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "button1_click", null));}
int _i = 0;
RDebugUtils.currentLine=1114112;
 //BA.debugLineNum = 1114112;BA.debugLine="Private Sub Button1_Click";
RDebugUtils.currentLine=1114113;
 //BA.debugLineNum = 1114113;BA.debugLine="For i=0 To FlexGrid1.RowCount-1";
{
final int step1 = 1;
final int limit1 = (int) (mostCurrent._flexgrid1._getrowcount()-1);
_i = (int) (0) ;
for (;_i <= limit1 ;_i = _i + step1 ) {
RDebugUtils.currentLine=1114114;
 //BA.debugLineNum = 1114114;BA.debugLine="FlexGrid1.SetRowHeight(i,70*(160dip/160))";
mostCurrent._flexgrid1._setrowheight(_i,(int) (70*(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (160))/(double)160)));
 }
};
RDebugUtils.currentLine=1114116;
 //BA.debugLineNum = 1114116;BA.debugLine="End Sub";
return "";
}
public static String  _button2_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "button2_click", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "button2_click", null));}
RDebugUtils.currentLine=1048576;
 //BA.debugLineNum = 1048576;BA.debugLine="Private Sub Button2_Click";
RDebugUtils.currentLine=1048577;
 //BA.debugLineNum = 1048577;BA.debugLine="FlexGrid1.AddRowAt(3,Array (3,3,False,3,Null,3),T";
mostCurrent._flexgrid1._addrowat((int) (3),new Object[]{(Object)(3),(Object)(3),(Object)(anywheresoftware.b4a.keywords.Common.False),(Object)(3),anywheresoftware.b4a.keywords.Common.Null,(Object)(3)},anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=1048578;
 //BA.debugLineNum = 1048578;BA.debugLine="FlexGrid1.SetRowHeight(3,70*(160dip/160))";
mostCurrent._flexgrid1._setrowheight((int) (3),(int) (70*(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (160))/(double)160)));
RDebugUtils.currentLine=1048579;
 //BA.debugLineNum = 1048579;BA.debugLine="End Sub";
return "";
}
public static String  _flexgrid1_cellclick(int _row,int _col) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "flexgrid1_cellclick", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "flexgrid1_cellclick", new Object[] {_row,_col}));}
boolean _b = false;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bm = null;
String _i = "";
String _f = "";
String _d = "";
String _s = "";
RDebugUtils.currentLine=393216;
 //BA.debugLineNum = 393216;BA.debugLine="Sub FlexGrid1_CellClick(Row As Int, Col As Int)";
RDebugUtils.currentLine=393217;
 //BA.debugLineNum = 393217;BA.debugLine="If Col=0 Then";
if (_col==0) { 
RDebugUtils.currentLine=393218;
 //BA.debugLineNum = 393218;BA.debugLine="FlexGrid1.SelectRow(Row)";
mostCurrent._flexgrid1._selectrow(_row);
 }else {
RDebugUtils.currentLine=393220;
 //BA.debugLineNum = 393220;BA.debugLine="Select FlexGrid1.GetTypeCol(Col)";
switch (BA.switchObjectToInt(mostCurrent._flexgrid1._gettypecol(_col),mostCurrent._flexgrid1._typecheck,mostCurrent._flexgrid1._typeimage,mostCurrent._flexgrid1._typeint,mostCurrent._flexgrid1._typefloat,mostCurrent._flexgrid1._typedouble,mostCurrent._flexgrid1._typestring)) {
case 0: {
RDebugUtils.currentLine=393222;
 //BA.debugLineNum = 393222;BA.debugLine="Dim B As Boolean = FlexGrid1.GetCellValue(Row,";
_b = BA.ObjectToBoolean(mostCurrent._flexgrid1._getcellvalue(_row,_col));
RDebugUtils.currentLine=393223;
 //BA.debugLineNum = 393223;BA.debugLine="Log(\"Cell content: \" & B)";
anywheresoftware.b4a.keywords.Common.LogImpl("2393223","Cell content: "+BA.ObjectToString(_b),0);
 break; }
case 1: {
RDebugUtils.currentLine=393225;
 //BA.debugLineNum = 393225;BA.debugLine="Dim Bm As Bitmap = FlexGrid1.GetCellValue(Row,";
_bm = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
_bm = (anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper(), (android.graphics.Bitmap)(mostCurrent._flexgrid1._getcellvalue(_row,_col)));
RDebugUtils.currentLine=393226;
 //BA.debugLineNum = 393226;BA.debugLine="Log(\"Cell content: \" & Bm.IsInitialized)";
anywheresoftware.b4a.keywords.Common.LogImpl("2393226","Cell content: "+BA.ObjectToString(_bm.IsInitialized()),0);
 break; }
case 2: {
RDebugUtils.currentLine=393228;
 //BA.debugLineNum = 393228;BA.debugLine="Dim I As String = FlexGrid1.GetCellValue(Row,C";
_i = BA.ObjectToString(mostCurrent._flexgrid1._getcellvalue(_row,_col));
RDebugUtils.currentLine=393229;
 //BA.debugLineNum = 393229;BA.debugLine="Log(\"Cell content: \" & I)";
anywheresoftware.b4a.keywords.Common.LogImpl("2393229","Cell content: "+_i,0);
RDebugUtils.currentLine=393230;
 //BA.debugLineNum = 393230;BA.debugLine="FlexGrid1.EditCellonsite(Row,Col)";
mostCurrent._flexgrid1._editcellonsite(_row,_col);
 break; }
case 3: {
RDebugUtils.currentLine=393232;
 //BA.debugLineNum = 393232;BA.debugLine="Dim F As String = FlexGrid1.GetCellValue(Row,C";
_f = BA.ObjectToString(mostCurrent._flexgrid1._getcellvalue(_row,_col));
RDebugUtils.currentLine=393233;
 //BA.debugLineNum = 393233;BA.debugLine="Log(\"Cell content: \" & F)";
anywheresoftware.b4a.keywords.Common.LogImpl("2393233","Cell content: "+_f,0);
 break; }
case 4: {
RDebugUtils.currentLine=393235;
 //BA.debugLineNum = 393235;BA.debugLine="Dim D As String = FlexGrid1.GetCellValue(Row,C";
_d = BA.ObjectToString(mostCurrent._flexgrid1._getcellvalue(_row,_col));
RDebugUtils.currentLine=393236;
 //BA.debugLineNum = 393236;BA.debugLine="Log(\"Cell content: \" & D)";
anywheresoftware.b4a.keywords.Common.LogImpl("2393236","Cell content: "+_d,0);
 break; }
case 5: {
RDebugUtils.currentLine=393238;
 //BA.debugLineNum = 393238;BA.debugLine="Dim S As String = FlexGrid1.GetCellValue(Row,C";
_s = BA.ObjectToString(mostCurrent._flexgrid1._getcellvalue(_row,_col));
RDebugUtils.currentLine=393239;
 //BA.debugLineNum = 393239;BA.debugLine="Log(\"Cell content: \" & S)";
anywheresoftware.b4a.keywords.Common.LogImpl("2393239","Cell content: "+_s,0);
RDebugUtils.currentLine=393240;
 //BA.debugLineNum = 393240;BA.debugLine="FlexGrid1.EditCellonsite(Row,Col)";
mostCurrent._flexgrid1._editcellonsite(_row,_col);
 break; }
}
;
 };
RDebugUtils.currentLine=393243;
 //BA.debugLineNum = 393243;BA.debugLine="End Sub";
return "";
}
public static String  _flexgrid1_celllongclick(int _row,int _col) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "flexgrid1_celllongclick", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "flexgrid1_celllongclick", new Object[] {_row,_col}));}
RDebugUtils.currentLine=458752;
 //BA.debugLineNum = 458752;BA.debugLine="Sub FlexGrid1_CellLongClick(Row As Int, Col As Int";
RDebugUtils.currentLine=458753;
 //BA.debugLineNum = 458753;BA.debugLine="FlexGrid1.SelectCell(Row,Col,True)";
mostCurrent._flexgrid1._selectcell(_row,_col,anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=458754;
 //BA.debugLineNum = 458754;BA.debugLine="End Sub";
return "";
}
public static String  _flexgrid1_headclick(int _index) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "flexgrid1_headclick", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "flexgrid1_headclick", new Object[] {_index}));}
RDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub FlexGrid1_HeadClick(Index As Int)";
RDebugUtils.currentLine=327681;
 //BA.debugLineNum = 327681;BA.debugLine="Log(\"Click Head Col: \" & Index)";
anywheresoftware.b4a.keywords.Common.LogImpl("2327681","Click Head Col: "+BA.NumberToString(_index),0);
RDebugUtils.currentLine=327682;
 //BA.debugLineNum = 327682;BA.debugLine="FlexGrid1.Selectcol(Index)";
mostCurrent._flexgrid1._selectcol(_index);
RDebugUtils.currentLine=327683;
 //BA.debugLineNum = 327683;BA.debugLine="End Sub";
return "";
}
public static String  _flexgrid1_modified(int _row,int _col) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "flexgrid1_modified", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "flexgrid1_modified", new Object[] {_row,_col}));}
RDebugUtils.currentLine=524288;
 //BA.debugLineNum = 524288;BA.debugLine="Sub FlexGrid1_Modified(Row As Int, Col As Int)";
RDebugUtils.currentLine=524289;
 //BA.debugLineNum = 524289;BA.debugLine="If Col=1 Then";
if (_col==1) { 
RDebugUtils.currentLine=524290;
 //BA.debugLineNum = 524290;BA.debugLine="Log(FlexGrid1.GetCellValue(Row,Col))";
anywheresoftware.b4a.keywords.Common.LogImpl("2524290",BA.ObjectToString(mostCurrent._flexgrid1._getcellvalue(_row,_col)),0);
RDebugUtils.currentLine=524291;
 //BA.debugLineNum = 524291;BA.debugLine="FlexGrid1.SetCellValue(0,3,\"Totale: \" & Ev.Calcu";
mostCurrent._flexgrid1._setcellvalue((int) (0),(int) (3),(Object)("Totale: "+BA.NumberToString(mostCurrent._ev._calculate("1+sum(0,1,9,1)"))));
 };
RDebugUtils.currentLine=524293;
 //BA.debugLineNum = 524293;BA.debugLine="End Sub";
return "";
}
}